
#include "common.h"

struct _mnc
{
	int mcc;
	int mnc;
	char *data;
};

struct _mcc
{
	int mcc;
	char *data;
};

static struct _mcc mcc_list[] = {
{202 , "Greece"},
{204 , "Netherlands"},
{206 , "Belgium"},
{208 , "France"},
{212 , "Monaco"},
{213 , "Andorra"},
{214 , "Spain"},
{216 , "Hungary"},
{218 , "Bosnia and Herzegovina"},
{219 , "Croatia"},
{220 , "Serbia and Montenegro"},
{222 , "Italy"},
{225 , "Vatican City State"},
{226 , "Romania"},
{228 , "Switzerland"},
{230 , "Czech Republic"},
{231 , "Slovakia"},
{232 , "Austria"},
{234 , "United Kingdom"},
{235 , "United Kingdom"},
{238 , "Denmark"},
{240 , "Sweden"},
{242 , "Norway"},
{244 , "Finland"},
{246 , "Lithuania"},
{247 , "Latvia"},
{248 , "Estonia"},
{250 , "Russian Federation"},
{255 , "Ukraine"},
{257 , "Belarus"},
{259 , "Moldova"},
{260 , "Poland"},
{262 , "Germany"},
{266 , "Gibraltar (UK)"},
{268 , "Portugal"},
{270 , "Luxembourg"},
{272 , "Ireland"},
{274 , "Iceland"},
{276 , "Albania"},
{278 , "Malta"},
{280 , "Cyprus"},
{282 , "Georgia"},
{283 , "Armenia"},
{284 , "Bulgaria"},
{286 , "Turkey"},
{288 , "Faroe Islands (Denmark)"},
{290 , "Greenland (Denmark)"},
{292 , "San Marino"},
{293 , "Slovenia"},
{294 , "Republic of Macedonia"},
{295 , "Liechtenstein"},
{302 , "Canada"},
{308 , "Saint Pierre and Miquelon (France)"},
{310 , "United States of America"},
{311 , "United States of America"},
{312 , "United States of America"},
{313 , "United States of America"},
{314 , "United States of America"},
{315 , "United States of America"},
{316 , "United States of America"},
{330 , "Puerto Rico (US)"},
{332 , "United States Virgin Islands (US)"},
{334 , "Mexico"},
{338 , "Jamaica"},
{340 , "Guadeloupe (France)"},
{340 , "Martinique (France)"},
{342 , "Barbados"},
{344 , "Antigua and Barbuda"},
{346 , "Cayman Islands (UK)"},
{348 , "British Virgin Islands (UK)"},
{350 , "Bermuda (UK)"},
{352 , "Grenada"},
{354 , "Montserrat (UK)"},
{356 , "Saint Kitts and Nevis"},
{358 , "Saint Lucia"},
{360 , "Saint Vincent and the Grenadines"},
{362 , "Netherlands Antilles (Netherlands)"},
{363 , "Aruba (Netherlands)"},
{364 , "Bahamas"},
{365 , "Anguilla"},
{366 , "Dominica"},
{368 , "Cuba"},
{370 , "Dominican Republic"},
{372 , "Haiti"},
{374 , "Trinidad and Tobago"},
{376 , "Turks and Caicos Islands (UK)"},
{400 , "Azerbaijani Republic"},
{401 , "Kazakhstan"},
{402 , "Bhutan"},
{404 , "India"},
{405 , "India"},
{410 , "Pakistan"},
{412 , "Afghanistan"},
{413 , "Sri Lanka"},
{414 , "Myanmar"},
{415 , "Lebanon"},
{416 , "Jordan"},
{417 , "Syria"},
{418 , "Iraq"},
{419 , "Kuwait"},
{420 , "Saudi Arabia"},
{421 , "Yemen"},
{422 , "Oman"},
{424 , "United Arab Emirates"},
{425 , "Israel"},
{426 , "Bahrain"},
{427 , "Qatar"},
{428 , "Mongolia"},
{429 , "Nepal"},
{430 , "United Arab Emirates (Abu Dhabi)"},
{431 , "United Arab Emirates (Dubai)"},
{432 , "Iran"},
{434 , "Uzbekistan"},
{436 , "Tajikistan"},
{437 , "Kyrgyz Republic"},
{438 , "Turkmenistan"},
{440 , "Japan"},
{441 , "Japan"},
{450 , "Korea, South"},
{452 , "Viet Nam"},
{454 , "Hong Kong (PRC)"},
{455 , "Macao (PRC)"},
{456 , "Cambodia"},
{457 , "Laos"},
{460 , "China"},
{466 , "Taiwan"},
{467 , "Korea, North"},
{470 , "Bangladesh"},
{472 , "Maldives"},
{502 , "Malaysia"},
{505 , "Australia"},
{510 , "Indonesia"},
{514 , "East Timor"},
{515 , "Philippines"},
{520 , "Thailand"},
{525 , "Singapore"},
{528 , "Brunei Darussalam"},
{530 , "New Zealand"},
{534 , "Northern Mariana Islands (US)"},
{535 , "Guam (US)"},
{536 , "Nauru"},
{537 , "Papua New Guinea"},
{539 , "Tonga"},
{540 , "Solomon Islands"},
{541 , "Vanuatu"},
{542 , "Fiji"},
{543 , "Wallis and Futuna (France)"},
{544 , "American Samoa (US)"},
{545 , "Kiribati"},
{546 , "New Caledonia (France)"},
{547 , "French Polynesia (France)"},
{548 , "Cook Islands (NZ)"},
{549 , "Samoa"},
{550 , "Federated States of Micronesia"},
{551 , "Marshall Islands"},
{552 , "Palau"},
{602 , "Egypt"},
{603 , "Algeria"},
{604 , "Morocco"},
{605 , "Tunisia"},
{606 , "Libya"},
{607 , "Gambia"},
{608 , "Senegal"},
{609 , "Mauritania"},
{610 , "Mali"},
{611 , "Guinea"},
{612 , "Cte d'Ivoire"},
{613 , "Burkina Faso"},
{614 , "Niger"},
{615 , "Togolese Republic"},
{616 , "Benin"},
{617 , "Mauritius"},
{618 , "Liberia"},
{619 , "Sierra Leone"},
{620 , "Ghana"},
{621 , "Nigeria"},
{622 , "Chad"},
{623 , "Central African Republic"},
{624 , "Cameroon"},
{625 , "Cape Verde"},
{626 , "So Tom and Prncipe"},
{627 , "Equatorial Guinea"},
{628 , "Gabonese Republic"},
{629 , "Republic of the Congo"},
{630 , "Democratic Republic of the Congo"},
{631 , "Angola"},
{632 , "Guinea-Bissau"},
{633 , "Seychelles"},
{634 , "Sudan"},
{635 , "Rwandese Republic"},
{636 , "Ethiopia"},
{637 , "Somalia"},
{638 , "Djibouti"},
{639 , "Kenya"},
{640 , "Tanzania"},
{641 , "Uganda"},
{642 , "Burundi"},
{643 , "Mozambique"},
{645 , "Zambia"},
{646 , "Madagascar"},
{647 , "Runion (France)"},
{648 , "Zimbabwe"},
{649 , "Namibia"},
{650 , "Malawi"},
{651 , "Lesotho"},
{652 , "Botswana"},
{653 , "Swaziland"},
{654 , "Comoros"},
{655 , "South Africa"},
{657 , "Eritrea"},
{702 , "Belize"},
{704 , "Guatemala"},
{706 , "El Salvador"},
{708 , "Honduras"},
{710 , "Nicaragua"},
{712 , "Costa Rica"},
{714 , "Panama"},
{716 , "Peru"},
{722 , "Argentine Republic"},
{724 , "Brazil"},
{730 , "Chile"},
{732 , "Colombia"},
{734 , "Venezuela"},
{736 , "Bolivia"},
{738 , "Guyana"},
{740 , "Ecuador"},
{742 , "French Guiana (France)"},
{744 , "Paraguay"},
{746 , "Suriname"},
{748 , "Uruguay"},
{901, "SATALITE"},
};

static struct _mnc mnc_list[] = {
{202, 10, "Telestet"},
{202, 1, "Cosmote"},
{202, 5, "Vodafone - Panafon"},
{202, 9, "Info Quest S.A."},
{204, 12, "BT Ignite Nederland B.V."},
{204, 16, "BEN Nederland B.V."},
{204, 20, "Dutchtone N.V."},
{204, 21, "NS Railinfrabeheer B.V."},
{204, 2, "Tele2 (Netherlands) B.V."},
{204, 4, "Vodafone Libertel N.V."},
{204, 8, "KPN Telecom B.V."},
{206, 10, "Mobistar"},
{206, 1, "Proximus"},
{206, 20, "Base"},
{208, 10, "S.F.R."},
{208, 11, "S.F.R. (UMTS)"},
{208, 13, "SFR (Zones Blanches)"},
{208, 1, "Orange France"},
{208, 20, "Bouygues Telecom"},
{208, 21, "Bouygues Telecom"},
{208, 2, "Orange France"},
{208, 5, "Globalstar Europe"},
{208, 6, "Globalstar Europe"},
{208, 7, "Globalstar Europe"},
{208, 88, "Bouygues Telecom (Zones Blanches)"},
{213, 3, "Mobiland"},
{214, 1, "Vodafone"},
{214, 3, "Amena"},
{214, 4, "Xfera"},
{214, 7, "Movistar"},
{216, 1, "Pannon GSM"},
{216, 30, "Westel Mobile"},
{216, 70, "Vodafone"},
{218, 3, "Eronet Mobile Communications Ltd."},
{218, 5, "MOBI'S (Mobilina Srpske)"},
{218, 90, "GSMBIH"},
{219, 10, "VIPnet/VIPnet d.o.o."},
{219, 1, "T-Mobile Hrvatska d.o.o./T-Mobile Croatia LLC"},
{219, 2, "Tele2/Tele2 d.o.o."},
{220, 1, "Telenor d.o.o."},
{220, 3, "Telekom Srbija a.d."},
{220, 5, "Vip mobile d.o.o."},
{222, 10, "Omnitel Pronto Italia (OPI)"},
{222, 1, "Telecom Italia Mobile (TIM)"},
{222, 2, "Elsacom"},
{222, 77, "IPSE 2000"},
{222, 88, "Wind"},
{222, 98, "Blu"},
{222, 99, "H3G"},
{226, 10, "Orange Romania"},
{226, 1, "Vodafone Romania SA"},
{226, 3, "Cosmorom"},
{228, 12, "TDC Switzerland AG"},
{228, 1, "Swisscom Mobile AG"},
{228, 2, "TDC Switzerland AG"},
{228, 3, "Orange Communications SA"},
{228, 51, "Bebbicell AG"},
{228, 5, "Comfone AG"},
{228, 6, "SBB AG"},
{228, 7, "IN&Phone SA"},
{228, 8, "Tele2 Telecommunications AG"},
{230, 1, "T-Mobile Czech Republic a.s."},
{230, 2, "Telefnica O2 Czech Republic a.s."},
{230, 3, "Vodafone Czech Republic a.s."},
{230, 4, "Mobilkom a.s."},
{230, 98, "Sprava Zeleznicni Dopravni Cesty"},
{230, 99, "Vodafone Czech Republic a.s. R&D Centre"},
{231, 1, "Orange, GSM"},
{231, 2, "Eurotel, GSM & NMT"},
{231, 4, "Eurotel, UMTS"},
{231, 5, "Orange, UMTS"},
{232, 10, "Hutchison 3G Austria"},
{232, 1, "A1"},
{232, 3, "T-Mobile"},
{232, 5, "One"},
{232, 7, "tele.ring"},
{232, 8, "Telefonica Austria"},
{232, 9, "One"},
{234, 0, "British Telecom"},
{234, 10, "O2 UK Ltd."},
{234, 11, "O2 UK Ltd."},
{234, 12, "Ntework Rail Infrastructure Ltd"},
{234, 13, "Ntework Rail Infrastructure Ltd"},
{234, 14, "Hay Systems Ltd"},
{234, 15, "Vodafone Ltd."},
{234, 16, "Opal Telecom Ltd"},
{234, 17, "Flextel Ltd"},
{234, 18, "Wire9 Telecom plc"},
{234, 19, "Teleware plc"},
{234, 1, "Mapesbury Communications Ltd."},
{234, 20, "Hutchison 3G UK Ltd."},
{234, 2, "O2 UK Ltd."},
{234, 30, "T-Mobile UK"},
{234, 31, "T-Mobile UK"},
{234, 32, "T-Mobile UK"},
{234, 33, "Orange"},
{234, 34, "Orange"},
{234, 3, "Jersey Telenet Ltd"},
{234, 4, "FMS Solutions Ltd"},
{234, 50, "Jersey Telecom"},
{234, 55, "Cable and Wireless Guensey Ltd"},
{234, 58, "Manx Telecom"},
{234, 5, "Colt Mobile Telecommunications Ltd"},
{234, 6, "Internet One Ltd"},
{234, 75, "Inquam Telecom (Holdings) Ltd."},
{234, 76, "British Telecom"},
{234, 78, "Airwave mmO2 Ltd"},
{234, 7, "Cable and Wireless plc"},
{234, 9, "Wire9 Telecom plc"},
{238, 10, "TDC Mobil"},
{238, 1, "TDC Mobil"},
{238, 20, "Telia"},
{238, 2, "Sonofon"},
{238, 30, "Telia Mobile"},
{238, 3, "MIGway A/S"},
{238, 6, "Hi3G"},
{238, 77, "Tele2"},
{238, 7, "Barablu Mobile Ltd."},
{240, 10, "Spring Mobil AB"},
{240, 11, "Linholmen Science Park AB"},
{240, 12, "Barablu Mobile Scandinavia Ltd"},
{240, 13, "Ventelo Sverige AB"},
{240, 14, "TDC Mobil A/S"},
{240, 15, "Wireless Maingate Nordic AB"},
{240, 16, "42IT AB"},
{240, 1, "Telia Sonera AB"},
{240, 20, "Wireless Maingate Message Services AB"},
{240, 21, "Banverket"},
{240, 2, "H3G Access AB"},
{240, 3, "Nordisk Mobiltelefon AS"},
{240, 4, "3G Infrastructure Services AB"},
{240, 5, "Svenska UMTS-Nt AB"},
{240, 6, "Telenor Sverige AB"},
{240, 7, "Tele2 Sverige AB"},
{240, 8, "Telenor Sverige AB"},
{240, 9, "Telenor Mobile Sverige"},
{242, 1, "Telenor Mobil AS"},
{242, 2, "Netcom GSM AS"},
{242, 3, "Teletopia Mobile Communications AS"},
{242, 4, "Tele2 Norge AS"},
{244, 12, "Finnet Networks Ltd."},
{244, 14, "Alands Mobiltelefon AB"},
{244, 16, "Oy Finland Tele2 AB"},
{244, 21, "Saunalahti Group Ltd."},
{244, 4, "Finnet Networks Ltd."},
{244, 5, "Elisa Matkapuhelinpalvelut Ltd."},
{244, 91, "Sonera Carrier Networks Oy"},
{244, 9, "Finnet Group"},
{246, 1, "Omnitel"},
{246, 2, "Bit GSM"},
{246, 3, "Tele2"},
{247, 1, "Latvian Mobile Phone"},
{247, 2, "Tele2"},
{247, 3, "Telekom Baltija"},
{247, 4, "Beta Telecom"},
{248, 1, "EMT GSM"},
{248, 2, "RLE"},
{248, 3, "Tele2"},
{248, 4, "OY Top Connect"},
{248, 5, "AS Bravocom Mobiil"},
{248, 6, "OY ViaTel"},
{248, 71, "Siseministeerium (Ministry of Interior)"},
{248, 7, "Televrgu AS"},
{250, 10, "Don Telecom"},
{250, 11, "Orensot"},
{250, 12, "Baykal Westcom"},
{250, 13, "Kuban GSM"},
{250, 16, "New Telephone Company"},
{250, 17, "Ermak RMS"},
{250, 19, "Volgograd Mobile"},
{250, 1, "Mobile Telesystems"},
{250, 20, "ECC"},
{250, 28, "Extel"},
{250, 2, "Megafon"},
{250, 39, "Uralsvyazinform"},
{250, 3, "Nizhegorodskaya Cellular Communications"},
{250, 44, "Stuvtelesot"},
{250, 4, "Sibchallenge"},
{250, 5, "Mobile Comms System"},
{250, 7, "BM Telecom"},
{250, 92, "Printelefone"},
{250, 93, "Telecom XXI"},
{250, 99, "Bec Line GSM"},
{255, 1, "Ukrainian Mobile Communication, UMC"},
{255, 21, "CJSC - Telesystems of Ukraine"},
{255, 2, "Ukranian Radio Systems, URS"},
{255, 3, "Kyivstar GSM"},
{255, 4, "International Telecommunications Ltd."},
{255, 5, "Golden Telecom"},
{255, 6, "Astelit"},
{255, 7, "Ukrtelecom"},
{257, 1, "MDC Velcom"},
{257, 2, "MTS"},
{259, 1, "Orange Moldova GSM"},
{259, 2, "Moldcell GSM"},
{259, 4, "Eventis Mobile GSM"},
{260, 10, "Telefony Opalenickie"},
{260, 1, "Plus GSM (Polkomtel S.A.)"},
{260, 2, "ERA GSM (Polska Telefonia Cyfrowa Sp. Z.o.o.)"},
{260, 3, "Idea (Polska Telefonia Komrkowa Centertel Sp. Z.o.o)"},
{260, 4, "Tele2 Polska (Tele2 Polska Sp. Z.o.o.)"},
{260, 5, "IDEA (UMTS)/PTK Centertel sp. Z.o.o."},
{260, 6, "Netia Mobile"},
{260, 7, "Premium internet"},
{260, 8, "E-Telko"},
{260, 9, "Telekomunikacja Kolejowa (GSM-R)"},
{262, 10, "Arcor AG & Co."},
{262, 11, "O2 (Germany) GmbH & Co. OHG"},
{262, 12, "Dolphin Telecom (Deutschland) GmbH"},
{262, 13, "Mobilcom Multimedia GmbH"},
{262, 14, "Group 3G UMTS GmbH (Quam)"},
{262, 15, "Airdata AG"},
{262, 1, "T-Mobile Deutschland GmbH"},
{262, 2, "Vodafone D2 GmbH"},
{262, 3, "E-Plus Mobilfunk GmbH & Co. KG"},
{262, 4, "Vodafone D2 GmbH"},
{262, 5, "E-Plus Mobilfunk GmbH & Co. KG"},
{262, 6, "T-Mobile Deutschland GmbH"},
{262, 76, "Siemens AG, ICMNPGUSTA"},
{262, 77, "E-Plus Mobilfunk GmbH & Co. KG"},
{262, 7, "O2 (Germany) GmbH & Co. OHG"},
{262, 8, "O2 (Germany) GmbH & Co. OHG"},
{262, 9, "Vodafone D2 GmbH"},
{266, 1, "Gibtelecom GSM"},
{266, 9, "Cloud9 Mobile Communications"},
{268, 1, "Vodafone Telecel - Comunicaes Pessoais, S.A."},
{268, 3, "Optimus - Telecomunicaes, S.A."},
{268, 5, "Oniway - Inforcomunicaes, S.A."},
{268, 6, "TMN - Telecomunicaes Movis Nacionais, S.A."},
{270, 1, "P&T Luxembourg"},
{270, 77, "Tango"},
{270, 99, "Voxmobile S.A."},
{272, 1, "Vodafone Ireland Plc"},
{272, 2, "Digifone mm02 Ltd."},
{272, 3, "Meteor Mobile Communications Ltd."},
{272, 7, "Eircom"},
{272, 9, "Clever Communications Ltd."},
{274, 1, "Iceland Telecom Ltd."},
{274, 2, "Tal hf"},
{274, 3, "Islandssimi GSM ehf"},
{274, 4, "IMC Islande ehf"},
{274, 7, "IceCell ehf"},
{276, 1, "AMC"},
{276, 2, "Vodafone Albania"},
{276, 3, "Eagle Mobile"},
{278, 1, "Vodafone Malta"},
{278, 21, "go mobile"},
{280, 10, "Scancom (Cyprus) Ltd."},
{280, 1, "CYTA"},
{282, 1, "Geocell Ltd."},
{282, 2, "Magti GSM Ltd."},
{282, 3, "Iberiatel Ltd."},
{282, 4, "Mobitel Ltd."},
{284, 1, "M-Tel GSM BG"},
{284, 5, "Globul"},
{286, 1, "Turkcell"},
{286, 2, "Telsim GSM"},
{286, 3, "Aria"},
{286, 4, "Aycell"},
{288, 1, "Faroese Telecom - GSM"},
{288, 2, "Kall GSM"},
{290, 1, "Tele Greenland"},
{292, 1, "SMT - San Marino Telecom"},
{293, 40, "SI Mobil"},
{293, 41, "Mobitel"},
{293, 64, "T-2 d.o.o."},
{293, 70, "Tusmobil d.o.o."},
{294, 1, "T-Mobile"},
{294, 2, "Cosmofon"},
{294, 3, "Nov Operator"},
{295, 1, "Telecom FL AG"},
{295, 2, "Viag Europlatform AG"},
{295, 5, "Mobilkom (Liechstein) AG"},
{295, 77, "Tele2 AG"},
{297, 3, "MTEL d.o.o. Podgorica"},
{302, 36, "Clearnet"},
{302, 37, "Microcell"},
{302, 62, "Ice Wireless"},
{302, 63, "Aliant Mobility"},
{302, 64, "Bell Mobility"},
{302, 656, "Tbay Mobility"},
{302, 66, "MTS Mobility"},
{302, 67, "CityTel Mobility"},
{302, 68, "Sask Tel Mobility"},
{302, 71, "Globalstar"},
{302, 72, "Rogers Wireless"},
{302, 86, "Telus Mobility"},
{308, 1, "St. Pierre-et-Miquelon Tlcom"},
{310, 100, "New Mexico RSA 4 East Ltd. Partnership"},
{310, 10, "MCI"},
{310, 110, "Pacific Telecom Inc"},
{310, 120, "Sprint"},
{310, 12, "Verizon Wireless"},
{310, 130, "Carolina West Wireless"},
{310, 13, "Mobile Tel Inc."},
{310, 140, "GTA Wireless LLC"},
{310, 150, "Cingular Wireless"},
{310, 160, "T-Mobile USA"},
{310, 16, "Cricket Communications"},
{310, 170, "Cingular Wireless"},
{310, 17, "North Sight Communications Inc."},
{310, 180, "West Central Wireless"},
{310, 190, "Alaska Wireless Communications LLC"},
{310, 200, "T-Mobile USA"},
{310, 20, "Union Telephone Company"},
{310, 210, "T-Mobile USA"},
{310, 220, "T-Mobile USA"},
{310, 230, "T-Mobile USA"},
{310, 240, "T-Mobile USA"},
{310, 250, "T-Mobile USA"},
{310, 260, "T-Mobile USA"},
{310, 270, "T-Mobile USA"},
{310, 280, "Contennial Puerto Rio License Corp."},
{310, 290, "Nep Cellcorp Inc."},
{310, 30, "Centennial Communications"},
{310, 310, "T-Mobile USA"},
{310, 320, "Smith Bagley Inc, dba Cellular One"},
{310, 330, "AN Subsidiary LLC"},
{310, 340, "High Plains Midwest LLC, dba Wetlink Communications"},
{310, 34, "Nevada Wireless LLC"},
{310, 350, "Mohave Cellular L.P."},
{310, 360, "Cellular Network Partnership dba Pioneer Cellular"},
{310, 370, "Guamcell Cellular and Paging"},
{310, 380, "New Cingular Wireless PCS, LLC"},
{310, 390, "TX-11 Acquistion LLC"},
{310, 400, "Wave Runner LLC"},
{310, 40, "MTA Communications dba MTA Wireless"},
{310, 410, "Cingular Wireless"},
{310, 420, "Cincinnati Bell Wireless LLC"},
{310, 430, "Alaska Digitel LLC"},
{310, 440, "Numerex Corp."},
{310, 450, "North East Cellular Inc."},
{310, 460, "TMP Corporation"},
{310, 480, "Choice Phone LLC"},
{310, 490, "SunCom Wireless"},
{310, 500, "Public Service Cellular, Inc."},
{310, 50, "ACS Wireless Inc."},
{310, 510, "Airtel Wireless LLC"},
{310, 520, "VeriSign"},
{310, 540, "Oklahoma Western Telephone Company"},
{310, 550, "Wireless Solutions International"},
{310, 560, "American Cellular Corporation"},
{310, 570, "MTPCS LLC"},
{310, 580, "Inland Cellular Telephone Company"},
{310, 590, "Western Wireless Corporation"},
{310, 600, "New Cell Inc. dba Cellcom"},
{310, 60, "Consolidated Telcom"},
{310, 610, "Elkhart Telephone Co. Inc. dba Epic Touch Co."},
{310, 620, "Coleman County Telecommunications Inc. (Trans Texas PCS)"},
{310, 640, "Airadigm Communications"},
{310, 650, "Jasper Wireless Inc."},
{310, 660, "T-Mobile USA"},
{310, 670, "AT&T Mobility Vanguard Services"},
{310, 690, "Conestoga Wireless Company"},
{310, 700, "Cross Valiant Cellular Partnership"},
{310, 70, "Highland Cellular, Inc."},
{310, 710, "Arctic Slopo Telephone Association Cooperative"},
{310, 720, "Wireless Solutions International Inc."},
{310, 730, "Sea Mobile"},
{310, 750, "East Kentucky Network LLC dba Appalachian Wireless"},
{310, 760, "Panhandle Telecommunications Systems Inc."},
{310, 770, "Iowa Wireless Services LLC dba I Wireless"},
{310, 780, "Connect Net Inc"},
{310, 790, "PinPoint Communications Inc."},
{310, 800, "T-Mobile USA"},
{310, 80, "Corr Wireless Communications LLC"},
{310, 810, "Brazos Cellular Communications Ltd."},
{310, 820, "South Canaan Cellular Communications Co. LP"},
{310, 830, "Caprock Cellular Ltd. Partnership"},
{310, 840, "Edge Mobile LLC"},
{310, 850, "Aeris Communications, Inc."},
{310, 860, "TX RSA 15B2, LP dba Five Star Wireless"},
{310, 870, "Kaplan Telephone Company Inc."},
{310, 880, "Advantage Cellular Systems, Inc."},
{310, 890, "Rural Cellular Corporation"},
{310, 900, "Taylor Telecommunications Ltd."},
{310, 90, "Edge Wireless LLC"},
{310, 910, "Southern IL RSA Partnership dba First Cellular of Southern Illinois"},
{310, 920, "Get Mobile"},
{310, 930, "Copper Valley Wireless"},
{310, 950, "Texas RSA 1 dba XIT Cellular"},
{310, 960, "UBET Wireless"},
{310, 970, "Globalstar USA"},
{310, 980, "New Cingular Wireless PCS LLC"},
{311, 0, "Mid-Tex Cellular Ltd."},
{311, 10, "Chariton Valley Communications Corp., Inc."},
{311, 110, "Alltel Communications Inc"},
{311, 120, "Choice Phone LLC"},
{311, 140, "MBO Wireless Inc./Cross Telephone Company"},
{311, 150, "Wilkes Cellular Inc."},
{311, 170, "PetroCom LLC"},
{311, 180, "Cingular Wireless, Licensee Pacific Telesis Mobile "},
{311, 190, "Cellular Properties Inc."},
{311, 200, "ARINC"},
{311, 20, "Missouri RSA No. 5 Partnership"},
{311, 210, "Farmers Cellular Telephone"},
{311, 230, "Cellular South Inc."},
{311, 240, "Cordova Wireless Communications Inc"},
{311, 250, "Wave Runner LLC"},
{311, 260, "SLO Cellular Inc. dba CellularOne of San Luis Obispo"},
{311, 270, "Alltel Communications Inc."},
{311, 271, "Alltel Communications Inc."},
{311, 272, "Alltel Communications Inc."},
{311, 273, "Alltel Communications Inc."},
{311, 274, "Alltel Communications Inc."},
{311, 275, "Alltel Communications Inc."},
{311, 276, "Alltel Communications Inc."},
{311, 277, "Alltel Communications Inc."},
{311, 278, "Alltel Communications Inc."},
{311, 279, "Alltel Communications Inc."},
{311, 280, "Verizon Wireless"},
{311, 281, "Verizon Wireless"},
{311, 282, "Verizon Wireless"},
{311, 283, "Verizon Wireless"},
{311, 284, "Verizon Wireless"},
{311, 285, "Verizon Wireless"},
{311, 286, "Verizon Wireless"},
{311, 287, "Verizon Wireless"},
{311, 288, "Verizon Wireless"},
{311, 289, "Verizon Wireless"},
{311, 290, "Pinpoint Wireless Inc."},
{311, 300, "Rutal Cellular Corporation"},
{311, 30, "Indigo Wireless, Inc."},
{311, 310, "Leaco Rural Telephone Company Inc"},
{311, 320, "Commnet Wireless LLC"},
{311, 330, "Bag Tussel Wireless LLC"},
{311, 340, "Illinois Valley Cellular"},
{311, 350, "Torrestar Networks Inc"},
{311, 360, "Stelera Wireless LLC"},
{311, 370, "GCI Communications Corp."},
{311, 380, "GreenFly LLC"},
{311, 390, "Midwest Wireless Holdings LLC"},
{311, 400, "New Cingular Wireless PCS LLC"},
{311, 40, "Commet Wireless, LLC"},
{311, 410, "Iowa RSA No.2 Ltd Partnership"},
{311, 420, "Northwest Missouri Cellular Limited Partnership"},
{311, 430, "RSA 1 Limited Partnership dba Cellular 29 Plus"},
{311, 440, "Bluegrass Cellular LLC"},
{311, 450, "Panhandle Telecommunication Systems Inc."},
{311, 460, "Fisher Wireless Services Inc"},
{311, 470, "Vitelcom Cellular Inc dba Innovative Wireless"},
{311, 480, "Verizon Wireless"},
{311, 481, "Verizon Wireless"},
{311, 482, "Verizon Wireless"},
{311, 483, "Verizon Wireless"},
{311, 484, "Verizon Wireless"},
{311, 485, "Verizon Wireless"},
{311, 486, "Verizon Wireless"},
{311, 487, "Verizon Wireless"},
{311, 488, "Verizon Wireless"},
{311, 489, "Verizon Wireless"},
{311, 490, "Strata8 Networks Inc/Wirefree Partners LLC"},
{311, 500, "CTC Telecom Inc"},
{311, 50, "Thumb Cellular Limited Partnership"},
{311, 510, "Benton-Lian Wireless"},
{311, 520, "Crossroads Wireless Inc"},
{311, 530, "Wireless Communications Venture"},
{311, 540, "Keystone Wireless Inc"},
{311, 550, "Commnet Midwest LLC"},
{311, 60, "Space Data Corporation"},
{311, 70, "Easterbrooke Cellular Corporation"},
{311, 80, "Pine Telephone Company dba Pine Cellular"},
{311, 90, "Siouxland PCS"},
{316, 10, "Nextel Communications Inc."},
{316, 11, "Southern Communications Services Inc."},
{334, 20, "Telcel"},
{338, 20, "Cable & Wireless Jamaica Ltd."},
{338, 50, "Mossel (Jamaica) Ltd."},
{340, 1, "Orange Carabe Mobiles"},
{340, 20, "Bouygues Telecom Carabe"},
{340, 2, "Outremer Telecom"},
{340, 3, "Saint Martin et Saint Barthelemy Telcell Sarl"},
{342, 600, "Cable & Wireless (Barbados) Ltd."},
{342, 820, "Sunbeach Communications"},
{344, 30, "APUA PCS"},
{344, 920, "Cable & Wireless (Antigua)"},
{344, 930, "AT&T Wireless (Antigua)"},
{346, 140, "Cable & Wireless (Cayman)"},
{348, 570, "Caribbean Cellular Telephone, Boatphone Ltd."},
{362, 51, "TELCELL GSM"},
{362, 69, "CT GSM"},
{362, 91, "SETEL GSM"},
{363, 1, "Setar GSM"},
{365, 10, "Weblinks Limited"},
{368, 1, "ETECSA"},
{370, 1, "Orange Dominicana, S.A."},
{370, 2, "Verizon Dominicana S.A."},
{370, 3, "Tricom S.A."},
{370, 4, "CentennialDominicana"},
{372, 1, "Comcel"},
{372, 2, "Digicel"},
{372, 3, "Rectel"},
{374, 12, "TSTT Mobile"},
{374, 130, "Digicel Trinidad and Tobago Ltd."},
{374, 140, "LaqTel Ltd."},
{376, 352, "IslandCom Communications Ltd."},
{400, 1, "Azercell Limited Liability Joint Venture"},
{400, 2, "Bakcell Limited Liabil ity Company"},
{400, 3, "Catel JV"},
{400, 4, "Azerphone LLC"},
{401, 1, "Kar-Tel llc"},
{401, 2, "TSC Kazak Telecom"},
{402, 11, "Bhutan Telecom Ltd"},
{402, 17, "B-Mobile of Bhutan Telecom"},
{404, 10, "Bharti Cellular Ltd."},
{404, 11, "Sterling Cellular Ltd."},
{404, 12, "Escotel Mobile Communications Pvt Ltd."},
{404, 13, "Hutchinson Essar South Ltd."},
{404, 14, "Spice Communications Ltd."},
{404, 15, "Aircell Digilink India Ltd."},
{404, 16, "Hexcom India"},
{404, 18, "Reliance Telecom Private Ltd."},
{404, 19, "Escotel Mobile Communications Pvt Ltd."},
{404, 1, "Aircell Digilink India Ltd.,"},
{404, 20, "Hutchinson Max Telecom"},
{404, 21, "BPL Mobile Communications Ltd."},
{404, 22, "Idea Cellular Ltd."},
{404, 24, "Idea Cellular Ltd."},
{404, 27, "BPL Cellular Ltd."},
{404, 2, "Bharti Mobile Ltd."},
{404, 30, "Usha Martin Telecom Ltd."},
{404, 31, "Bharti Mobinet Ltd."},
{404, 34, "Bharat Sanchar Nigam Ltd. (BSNL)"},
{404, 36, "Reliance Telecom Private Ltd."},
{404, 38, "Bharat Sanchar Nigam Ltd. (BSNL)"},
{404, 3, "Bharti Telenet Ltd."},
{404, 40, "Bharti Mobinet Ltd."},
{404, 41, "RPG Cellular"},
{404, 42, "Aircel Ltd."},
{404, 43, "BPL Mobile Cellular Ltd."},
{404, 44, "Spice Communications Ltd."},
{404, 46, "BPL Cellular Ltd."},
{404, 49, "Bharti Mobile Ltd."},
{404, 4, "Idea Cellular Ltd."},
{404, 50, "Reliance Telecom Private Ltd."},
{404, 51, "Bharat Sanchar Nigam Ltd. (BSNL)"},
{404, 52, "Reliance Telecom Private Ltd."},
{404, 53, "Bharat Sanchar Nigam Ltd. (BSNL)"},
{404, 54, "Bharat Sanchar Nigam Ltd. (BSNL)"},
{404, 55, "Bharat Sanchar Nigam Ltd. (BSNL)"},
{404, 56, "Escotel Mobile Communications Pvt Ltd."},
{404, 57, "Bharat Sanchar Nigam Ltd. (BSNL)"},
{404, 58, "Bharat Sanchar Nigam Ltd. (BSNL)"},
{404, 59, "Bharat Sanchar Nigam Ltd. (BSNL)"},
{404, 5, "Fascel Ltd."},
{404, 60, "Aircell Digilink India Ltd."},
{404, 62, "Bharat Sanchar Nigam Ltd. (BSNL)"},
{404, 64, "Bharat Sanchar Nigam Ltd. (BSNL)"},
{404, 66, "Bharat Sanchar Nigam Ltd. (BSNL)"},
{404, 67, "Reliance Telecom Private Ltd."},
{404, 68, "Mahanagar Telephone Nigam Ltd."},
{404, 69, "Mahanagar Telephone Nigam Ltd."},
{404, 6, "Bharti Mobile Ltd."},
{404, 70, "Hexicom India"},
{404, 71, "Bharat Sanchar Nigam Ltd. (BSNL)"},
{404, 72, "Bharat Sanchar Nigam Ltd. (BSNL)"},
{404, 73, "Bharat Sanchar Nigam Ltd. (BSNL)"},
{404, 74, "Bharat Sanchar Nigam Ltd. (BSNL)"},
{404, 75, "Bharat Sanchar Nigam Ltd. (BSNL)"},
{404, 76, "Bharat Sanchar Nigam Ltd. (BSNL)"},
{404, 77, "Bharat Sanchar Nigam Ltd. (BSNL)"},
{404, 78, "BTA Cellcom Ltd."},
{404, 7, "Idea Cellular Ltd."},
{404, 80, "Bharat Sanchar Nigam Ltd. (BSNL)"},
{404, 81, "Bharat Sanchar Nigam Ltd. (BSNL)"},
{404, 82, "Escorts Telecom Ltd."},
{404, 83, "Reliable Internet Services Ltd."},
{404, 84, "Hutchinson Essar South Ltd."},
{404, 85, "Reliance Telecom Private Ltd."},
{404, 86, "Hutchinson Essar South Ltd."},
{404, 87, "Escorts Telecom Ltd."},
{404, 88, "Escorts Telecom Ltd."},
{404, 89, "Escorts Telecom Ltd."},
{404, 90, "Bharti Cellular Ltd."},
{404, 92, "Bharti Cellular Ltd."},
{404, 93, "Bharti Cellular Ltd."},
{404, 94, "Bharti Cellular Ltd."},
{404, 95, "Bharti Cellular Ltd."},
{404, 96, "Bharti Cellular Ltd."},
{404, 97, "Bharti Cellular Ltd."},
{404, 98, "Bharti Cellular Ltd."},
{404, 9, "Reliance Telecom Private Ltd."},
{410, 1, "Mobilink"},
{410, 3, "PAK Telecom Mobile Ltd. (UFONE)"},
{412, 1, "AWCC"},
{412, 20, "Roshan"},
{412, 30, "New1"},
{412, 40, "Areeba Afghanistan"},
{412, 88, "Afghan Telecom"},
{413, 2, "MTN Network Ltd."},
{413, 3, "Celtel Lanka Ltd."},
{414, 1, "Myanmar Post and Telecommunication"},
{415, 32, "Cellis"},
{415, 33, "Cellis"},
{415, 34, "Cellis"},
{415, 35, "Cellis"},
{415, 36, "Libancell"},
{415, 37, "Libancell"},
{415, 38, "Libancell"},
{415, 39, "Libancell"},
{416, 1, "Fastlink"},
{416, 2, "Xpress"},
{416, 3, "Umniah"},
{416, 77, "Mobilecom"},
{417, 1, "Syriatel"},
{417, 2, "Spacetel Syria"},
{417, 9, "Syrian Telecom"},
{419, 2, "Mobile Telecommunications Company"},
{419, 3, "Wataniya Telecom"},
{420, 1, "Saudi Telecom"},
{420, 3, "Etihad Etisalat Company (Mobily)"},
{421, 1, "Yemen Mobile Phone Company"},
{421, 2, "Spacetel Yemen"},
{422, 2, "Oman Mobile Telecommunications Company (Oman Mobile)"},
{422, 3, "Oman Qatari Telecommunications Company (Nawras)"},
{422, 4, "Oman Telecommunications Company (Omantel)"},
{424, 2, "Etisalat"},
{425, 1, "Partner Communications Co. Ltd."},
{425, 2, "Cellcom Israel Ltd."},
{425, 3, "Pelephone Communications Ltd."},
{426, 1, "BHR Mobile Plus"},
{427, 1, "QATARNET"},
{428, 99, "Mobicom"},
{429, 1, "Nepal Telecommunications"},
{432, 11, "Telecommunication Company of Iran (TCI)"},
{432, 14, "Telecommunication Kish Co. (KIFZO)"},
{432, 19, "Telecommunication Company of Iran (TCI) - Isfahan Celcom "},
{434, 1, "Buztel"},
{434, 2, "Uzmacom"},
{434, 4, "Daewoo Unitel"},
{434, 5, "Coscom"},
{434, 7, "Uzdunrobita"},
{436, 1, "JC Somoncom"},
{436, 2, "CJSC Indigo Tajikistan"},
{436, 3, "TT mobile"},
{436, 4, "Josa Babilon-T"},
{436, 5, "CTJTHSC Tajik-tel"},
{437, 1, "Bitel GSM"},
{438, 1, "Barash Communication Technologies (BCTI)"},
{438, 2, "TM-Cell"},
{440, 10, "NTT DoCoMo Kansai Inc."},
{440, 11, "NTT DoCoMo Tokai Inc."},
{440, 12, "NTT DoCoMo Inc."},
{440, 13, "NTT DoCoMo Inc."},
{440, 14, "NTT DoCoMo Tohoku Inc."},
{440, 15, "NTT DoCoMo Inc."},
{440, 16, "NTT DoCoMo Inc."},
{440, 17, "NTT DoCoMo Inc."},
{440, 18, "NTT DoCoMo Tokai Inc."},
{440, 19, "NTT DoCoMo Hokkaido"},
{440, 1, "NTT DoCoMo, Inc."},
{440, 20, "NTT DoCoMo Hokuriku Inc."},
{440, 21, "NTT DoCoMo Inc."},
{440, 22, "NTT DoCoMo Kansai Inc."},
{440, 23, "NTT DoCoMo Tokai Inc."},
{440, 24, "NTT DoCoMo Chugoku Inc."},
{440, 25, "NTT DoCoMo Hokkaido Inc."},
{440, 26, "NTT DoCoMo Kyushu Inc."},
{440, 27, "NTT DoCoMoTohoku Inc."},
{440, 28, "NTT DoCoMo Shikoku Inc."},
{440, 29, "NTT DoCoMo Inc."},
{440, 2, "NTT DoCoMo Kansai, Inc."},
{440, 30, "NTT DoCoMo Inc."},
{440, 31, "NTT DoCoMo Kansai Inc."},
{440, 32, "NTT DoCoMo Inc."},
{440, 33, "NTT DoCoMo Tokai Inc."},
{440, 34, "NTT DoCoMo Kyushu Inc."},
{440, 35, "NTT DoCoMo Kansai Inc."},
{440, 36, "NTT DoCoMo Inc."},
{440, 37, "NTT DoCoMo Inc."},
{440, 38, "NTT DoCoMo Inc."},
{440, 39, "NTT DoCoMo Inc."},
{440, 3, "NTT DoCoMo Hokuriku, Inc."},
{440, 40, "Vodafone"},
{440, 41, "Vodafone"},
{440, 42, "Vodafone"},
{440, 43, "Vodafone"},
{440, 44, "Vodafone"},
{440, 45, "Vodafone"},
{440, 46, "Vodafone"},
{440, 47, "Vodafone"},
{440, 48, "Vodafone"},
{440, 49, "NTT DoCoMo Inc."},
{440, 4, "Vodafone"},
{440, 50, "KDDI Corporation"},
{440, 51, "KDDI Corporation"},
{440, 52, "KDDI Corporation"},
{440, 53, "KDDI Corporation"},
{440, 54, "KDDI Corporation"},
{440, 55, "KDDI Corporation"},
{440, 56, "KDDI Corporation"},
{440, 58, "NTT DoCoMo Kansai Inc."},
{440, 60, "NTT DoCoMo Kansai Inc."},
{440, 61, "NTT DoCoMo Chugoku Inc."},
{440, 62, "NTT DoCoMo Kyushu Inc."},
{440, 63, "NTT DoCoMo Inc."},
{440, 64, "NTT DoCoMo Inc."},
{440, 65, "NTT DoCoMo Shikoku Inc."},
{440, 66, "NTT DoCoMo Inc."},
{440, 67, "NTT DoCoMo Tohoku Inc."},
{440, 68, "NTT DoCoMo Kyushu Inc."},
{440, 69, "NTT DoCoMo Inc."},
{440, 6, "Vodafone"},
{440, 70, "KDDI Corporation"},
{440, 71, "KDDI Corporation"},
{440, 72, "KDDI Corporation"},
{440, 73, "KDDI Corporation"},
{440, 74, "KDDI Corporation"},
{440, 75, "KDDI Corporation"},
{440, 76, "KDDI Corporation"},
{440, 77, "KDDI Corporation"},
{440, 78, "Okinawa Cellular Telephone"},
{440, 79, "KDDI Corporation"},
{440, 7, "KDDI Corporation"},
{440, 80, "TU-KA Cellular Tokyo Inc."},
{440, 81, "TU-KA Cellular Tokyo Inc."},
{440, 82, "TU-KA Phone Kansai Inc."},
{440, 83, "TU-KA Cellular Tokai Inc."},
{440, 84, "TU-KA Phone Kansai Inc."},
{440, 85, "TU-KA Cellular Tokai Inc."},
{440, 86, "TU-KA Cellular Tokyo Inc."},
{440, 87, "NTT DoCoMo Chugoku Inc."},
{440, 88, "KDDI Corporation"},
{440, 89, "KDDI Corporation"},
{440, 8, "KDDI Corporation"},
{440, 90, "Vodafone"},
{440, 92, "Vodafone"},
{440, 93, "Vodafone"},
{440, 94, "Vodafone"},
{440, 95, "Vodafone"},
{440, 96, "Vodafone"},
{440, 97, "Vodafone"},
{440, 98, "Vodafone"},
{440, 99, "NTT DoCoMo Inc."},
{440, 9, "NTT DoCoMo Kansai Inc."},
{441, 40, "NTT DoCoMo Inc."},
{441, 41, "NTT DoCoMo Inc."},
{441, 42, "NTT DoCoMo Inc."},
{441, 43, "NTT DoCoMo Kansai Inc."},
{441, 44, "NTT DoCoMo Chugoku Inc."},
{441, 45, "NTT DoCoMo Shikoku Inc."},
{441, 50, "TU-KA Cellular Tokyo Inc."},
{441, 51, "TU-KA Phone Kansai Inc."},
{441, 61, "Vodafone"},
{441, 62, "Vodafone"},
{441, 63, "Vodafone"},
{441, 64, "Vodafone"},
{441, 65, "Vodafone"},
{441, 70, "KDDI Corporation"},
{441, 90, "NTT DoCoMo Inc."},
{441, 91, "NTT DoCoMo Inc."},
{441, 92, "NTT DoCoMo Inc."},
{441, 93, "NTT DoCoMo Hokkaido Inc."},
{441, 94, "NTT DoCoMo Tohoku Inc."},
{441, 98, "NTT DoCoMo Kyushu Inc."},
{441, 99, "NTT DoCoMo Kyushu Inc."},
{452, 1, "Mobifone"},
{452, 2, "Vinaphone"},
{454, 0, "GSM900/HKCSL"},
{454, 10, "GSM1800New World PCS Ltd."},
{454, 11, "MVNO/CHKTL"},
{454, 12, "GSM1800/Peoples Telephone Company Ltd."},
{454, 15, "3G Radio System/SMT3G"},
{454, 16, "GSM1800/Mandarin Communications Ltd."},
{454, 18, "GSM7800/Hong Kong CSL Ltd."},
{454, 19, "3G Radio System/Sunday3G"},
{454, 1, "MVNO/CITIC"},
{454, 2, "3G Radio System/HKCSL3G"},
{454, 20, "Public Mobile Networks/Reserved"},
{454, 21, "Public Mobile Networks/Reserved"},
{454, 22, "Public Mobile Networks/Reserved"},
{454, 23, "Public Mobile Networks/Reserved"},
{454, 24, "Public Mobile Networks/Reserved"},
{454, 25, "Public Mobile Networks/Reserved"},
{454, 26, "Public Mobile Networks/Reserved"},
{454, 27, "Public Mobile Networks/Reserved"},
{454, 28, "Public Mobile Networks/Reserved"},
{454, 29, "Public Mobile Networks/Reserved"},
{454, 3, "3G Radio System/Hutchison 3G"},
{454, 30, "Public Mobile Networks/Reserved"},
{454, 31, "Public Mobile Networks/Reserved"},
{454, 32, "Public Mobile Networks/Reserved"},
{454, 33, "Public Mobile Networks/Reserved"},
{454, 34, "Public Mobile Networks/Reserved"},
{454, 35, "Public Mobile Networks/Reserved"},
{454, 36, "Public Mobile Networks/Reserved"},
{454, 37, "Public Mobile Networks/Reserved"},
{454, 38, "Public Mobile Networks/Reserved"},
{454, 39, "Public Mobile Networks/Reserved"},
{454, 4, "GSM900/GSM1800/Hutchison"},
{454, 5, "CDMA/Hutchison"},
{454, 6, "GSM900/SmarTone"},
{454, 7, "MVNO/China Unicom International Ltd."},
{454, 8, "MVNO/Trident"},
{454, 9, "MVNO/China Motion Telecom (HK) Ltd."},
{455, 0, "Smartone Mobile Communications (Macao) Ltd."},
{455, 1, "CTM GSM"},
{455, 3, "Hutchison Telecom"},
{456, 18, "Camshin (Shinawatra)"},
{456, 1, "Mobitel (Cam GSM)"},
{456, 2, "Samart (Casacom)"},
{456, 3, "S Telecom (CDMA) (reserved)"},
{457, 1, "Lao Telecommunications"},
{457, 2, "ETL Mobile"},
{457, 8, "Millicom"},
{460, 0, "China Mobile"},
{460, 1, "China Unicom"},
{460, 3, "China Unicom CDMA"},
{460, 4, "China Satellite Global Star Network"},
{470, 1, "GramenPhone"},
{470, 2, "Aktel"},
{470, 3, "Mobile 2000"},
{472, 1, "DhiMobile"},
{502, 0, "Art900"},
{502, 12, "Maxis"},
{502, 13, "TM Touch"},
{502, 16, "DIGI"},
{502, 17, "TimeCel"},
{502, 18, "MITV Corporation Sdn. Bhd."},
{502, 19, "CelCom"},
{505, 11, "Telstra Corporation Ltd."},
{505, 12, "Hutchison Telecommunications (Australia) Pty. Ltd."},
{505, 14, "AAPT Ltd."},
{505, 15, "3GIS Pty Ltd. (Telstra & Hutchison 3G)"},
{505, 1, "Telstra Corporation Ltd."},
{505, 24, "Advanced Communications Technologies Pty. Ltd."},
{505, 2, "Optus Mobile Pty. Ltd."},
{505, 3, "Vodafone Network Pty. Ltd."},
{505, 4, "Department of Defence"},
{505, 5, "The Ozitel Network Pty. Ltd."},
{505, 6, "Hutchison 3G Australia Pty. Ltd."},
{505, 71, "Telstra Corporation Ltd."},
{505, 72, "Telstra Corporation Ltd."},
{505, 7, "Vodafone Network Pty. Ltd."},
{505, 88, "Localstar Holding Pty. Ltd."},
{505, 8, "One.Tel GSM 1800 Pty. Ltd."},
{505, 90, "Optus Ltd."},
{505, 99, "One.Tel GSM 1800 Pty. Ltd."},
{505, 9, "Airnet Commercial Australia Ltd."},
{510, 0, "PSN"},
{510, 10, "Telkomsel"},
{510, 11, "Excelcomindo"},
{510, 1, "Satelindo"},
{510, 21, "Indosat - M3"},
{510, 28, "Komselindo"},
{510, 8, "Natrindo (Lippo Telecom)"},
{515, 1, "Islacom"},
{515, 2, "Globe Telecom"},
{515, 3, "Smart Communications"},
{515, 5, "Digitel"},
{520, 0, "CAT CDMA"},
{520, 15, "ACT Mobile"},
{520, 1, "AIS GSM"},
{525, 12, "Digital Trunked Radio Network"},
{525, 1, "SingTel ST GSM900"},
{525, 2, "SingTel ST GSM1800"},
{525, 3, "MobileOne"},
{525, 5, "Starhub"},
{528, 11, "DST Com"},
{530, 0, "Reserved for AMPS MIN based IMSI's"},
{530, 1, "Vodafone New Zealand GSM Network"},
{530, 24, "NZ Communications - UMTS Network"},
{530, 2, "Teleom New Zealand CDMA Network"},
{530, 3, "Woosh Wireless - CDMA Network"},
{530, 4, "TelstraClear - GSM Network"},
{530, 5, "Telecom New Zealand - UMTS Ntework"},
{537, 1, "Bmobile"},
{537, 2, "Greencom"},
{537, 3, "Digicel Ltd"},
{539, 1, "Tonga Communications Corporation"},
{539, 43, "Shoreline Communication"},
{541, 1, "SMILE"},
{542, 1, "Vodafone"},
{546, 1, "OPT Mobilis"},
{547, 20, "Tikiphone"},
{548, 1, "Telecom Cook"},
{549, 1, "Telecom Samoa Cellular Ltd."},
{549, 27, "GoMobile SamoaTel Ltd"},
{550, 1, "FSM Telecom"},
{552, 1, "Palau National Communications Corp. (a.k.a. PNCC)"},
{602, 1, "EMS - Mobinil"},
{602, 2, "Vodafone Egypt"},
{603, 1, "Algrie Telecom"},
{603, 2, "Orascom Telecom Algrie"},
{604, 0, "Mditlcom (GSM)"},
{604, 1, "Ittissalat Al Maghrid"},
{605, 2, "Tunisie Telecom"},
{605, 3, "Orascom Telecom"},
{607, 1, "Gamcel"},
{607, 2, "Africell"},
{607, 3, "Comium Services Ltd"},
{608, 1, "Sonatel"},
{608, 2, "Sentel GSM"},
{609, 10, "Mauritel Mobiles"},
{609, 1, "Mattel S.A."},
{609, 2, "Chinguitel S.A."},
{610, 1, "Malitel"},
{611, 1, "Spacetel"},
{611, 2, "Sotelgui"},
{611, 5, "Cellcom Guine SA"},
{612, 2, "Atlantique Cellulaire"},
{612, 3, "Orange Cte d'Ivoire"},
{612, 4, "Comium Cte d'Ivoire"},
{612, 5, "Loteny Telecom"},
{612, 6, "Oricel Cte d'Ivoire"},
{612, 7, "Aircomm Cte d'Ivoire"},
{613, 2, "Celtel"},
{613, 3, "Telecel"},
{614, 1, "Sahel.Com"},
{614, 2, "Celtel"},
{614, 3, "Telecel"},
{615, 1, "Togo Telecom"},
{616, 1, "Libercom"},
{616, 2, "Telecel"},
{616, 3, "Spacetel Benin"},
{617, 10, "Emtel"},
{617, 1, "Cellplus"},
{617, 2, "Mahanagar Telephone (Mauritius) Ltd."},
{618, 4, "Comium Liberia"},
{619, 1, "Celtel"},
{619, 25, "Mobitel"},
{619, 2, "Millicom"},
{619, 3, "Africell"},
{619, 40, "Datatel (SL) Ltd GSM"},
{619, 4, "Comium (Sierra Leone) Ltd."},
{619, 50, "Dtatel (SL) Ltd CDMA"},
{619, 5, "Lintel (Sierra Leone) Ltd."},
{620, 1, "Spacefon"},
{620, 2, "Ghana Telecom Mobile"},
{620, 3, "Mobitel"},
{620, 4, "Kasapa Telecom Ltd."},
{621, 20, "Econet Wireless Nigeria Ltd."},
{621, 30, "MTN Nigeria Communications"},
{621, 40, "Nigeria Telecommunications Ltd."},
{622, 1, "Celtel"},
{622, 2, "Tchad Mobile"},
{623, 1, "Centrafrique Telecom Plus (CTP)"},
{623, 2, "Telecel Centrafrique (TC)"},
{623, 3, "Celca (Socatel)"},
{624, 1, "Mobile Telephone Networks Cameroon"},
{624, 2, "Orange Cameroun"},
{625, 1, "Cabo Verde Telecom"},
{625, 2, "T+Telecomunicaes"},
{626, 1, "Companhia Santomese de Telecomunicaes"},
{627, 1, "Guinea Ecuatorial de Telecomunicaciones Sociedad Annima "},
{628, 1, "Libertis S.A."},
{628, 2, "Telecel Gabon S.A."},
{628, 3, "Celtel Gabon S.A."},
{629, 10, "Libertis Telecom"},
{629, 1, "Celtel"},
{630, 1, "Vodacom Congo RDC sprl"},
{630, 5, "Supercell Sprl"},
{630, 86, "Congo-Chine Telecom s.a.r.l."},
{631, 2, "Unitel"},
{632, 1, "Guintel S.A."},
{632, 2, "Spacetel Guin-Bissau S.A."},
{633, 10, "Telecom (Seychelles) Ltd."},
{633, 1, "Cable & Wireless (Seychelles) Ltd."},
{633, 2, "Mediatech International Ltd."},
{634, 1, "SD Mobitel"},
{634, 2, "Areeba-Sudan"},
{635, 10, "MTN Rwandacell"},
{636, 1, "ETH MTN"},
{637, 30, "Golis Telecommunications Company"},
{638, 1, "Evatis"},
{639, 2, "Safaricom Ltd."},
{639, 3, "Kencell Communications Ltd."},
{640, 2, "MIC (T) Ltd."},
{640, 3, "Zantel"},
{640, 4, "Vodacom (T) Ltd."},
{640, 5, "Celtel (T) Ltd."},
{641, 10, "MTN Uganda Ltd."},
{641, 11, "Uganda Telecom Ltd."},
{641, 14, "House of Integrated Technology and Systems Uganda Ltd "},
{641, 1, "Celtel Uganda"},
{641, 22, "Warid Telecom Uganda Ltd."},
{642, 1, "Spacetel Burundi"},
{642, 2, "Safaris"},
{642, 3, "Telecel Burundi Company"},
{643, 1, "T.D.M. GSM"},
{643, 4, "VM Sarl"},
{645, 1, "Celtel Zambia Ltd."},
{645, 2, "Telecel Zambia Ltd."},
{645, 3, "Zamtel"},
{646, 1, "MADACOM"},
{646, 2, "Orange Madagascar"},
{646, 4, "Telecom Malagasy Mobile"},
{647, 0, "Orange La Runion"},
{647, 10, "Socit Runionnaise du Radiotlphone"},
{647, 2, "Outremer Telecom"},
{648, 1, "Net One"},
{648, 3, "Telecel"},
{648, 4, "Econet"},
{649, 1, "Mobile Telecommunications Ltd."},
{649, 3, "Powercom Pty Ltd"},
{650, 10, "Celtel ltd."},
{650, 1, "Telekom Network Ltd."},
{651, 1, "Vodacom Lesotho (pty) Ltd."},
{651, 2, "Econet Ezin-cel"},
{652, 1, "Mascom Wireless (Pty) Ltd."},
{652, 2, "Orange Botswana (Pty) Ltd."},
{653, 10, "Swazi MTN"},
{654, 1, "HURI - SNPT"},
{655, 10, "Mobile Telephone Networks"},
{655, 11, "SAPS Gauteng"},
{655, 1, "Vodacom (Pty) Ltd."},
{655, 21, "Cape Town Metropolitan Council"},
{655, 30, "Bokamoso Consortium"},
{655, 31, "Karabo Telecoms (Pty) Ltd."},
{655, 32, "Ilizwi Telecommunications"},
{655, 33, "Thinta Thinta Telecommunications"},
{655, 34, "Bokone Telecoms"},
{655, 35, "Kingdom Communications"},
{655, 36, "Amatole Telecommunication Services"},
{655, 6, "Sentech (Pty) Ltd."},
{655, 7, "Cell C (Pty) Ltd."},
{702, 67, "Belize Telecommunications Ltd., GSM 1900"},
{702, 68, "International Telecommunications Ltd. (INTELCO)"},
{704, 1, "Servicios de Comunicaciones Personales Inalmbricas, S.A. "},
{704, 2, "Comunicaciones Celulares S.A."},
{704, 3, "Telefnica Centroamrica Guatemala S.A."},
{706, 1, "CTE Telecom Personal, S.A. de C.V."},
{706, 2, "Digicel, S.A. de C.V."},
{706, 3, "Telemvil El Salvador, S.A."},
{708, 1, "Megatel"},
{708, 2, "Celtel"},
{710, 21, "Empresa Nicaragense de Telecomunicaciones, S.A. (ENITEL)"},
{710, 73, "Servicios de Comunicaciones, S.A. (SERCOM)"},
{712, 1, "Instituto Costarricense de Electricidad - ICE"},
{714, 1, "Cable & Wireless Panama S.A."},
{714, 2, "BSC de Panama S.A."},
{716, 10, "TIM Peru"},
{722, 10, "Compaia de Radiocomunicaciones Moviles S.A."},
{722, 20, "Nextel Argentina srl"},
{722, 310, "CTI PCS S.A."},
{722, 320, "Compaia de Telefonos del Interior Norte S.A."},
{722, 330, "Compaia de Telefonos del Interior S.A."},
{722, 341, "Telecom Personal S.A."},
{722, 70, "Telefonica Comunicaciones Personales S.A."},
{724, 0, "Telet"},
{724, 10, "ATL Algar"},
{724, 11, "Telems Cel"},
{724, 12, "Americel"},
{724, 13, "Telesp Cel"},
{724, 14, "Maxitel BA"},
{724, 15, "CTBC Cel"},
{724, 16, "BSE"},
{724, 17, "Ceterp Cel"},
{724, 18, "Norte Brasil Tel"},
{724, 19, "Telemig Cel"},
{724, 1, "CRT Cellular"},
{724, 21, "Telerj Cel"},
{724, 23, "Telest Cel"},
{724, 25, "Telebrasilia Cel"},
{724, 27, "Telegoias Cel"},
{724, 29, "Telemat Cel"},
{724, 2, "Global Telecom"},
{724, 31, "Teleacre Cel"},
{724, 33, "Teleron Cel"},
{724, 35, "Telebahia Cel"},
{724, 37, "Telergipe Cel"},
{724, 39, "Telasa Cel"},
{724, 3, "CTMR Cel"},
{724, 41, "Telpe Cel"},
{724, 43, "Telepisa Cel"},
{724, 45, "Telpa Cel"},
{724, 47, "Telern Cel"},
{724, 48, "Teleceara Cel"},
{724, 4, "BCP"},
{724, 51, "Telma Cel"},
{724, 53, "Telepara Cel"},
{724, 55, "Teleamazon Cel"},
{724, 57, "Teleamapa Cel"},
{724, 59, "Telaima Cel"},
{724, 5, "Telesc Cel"},
{724, 6, "Tess"},
{724, 7, "Sercontel Cel"},
{724, 8, "Maxitel MG"},
{724, 9, "Telepar Cel"},
{730, 10, "Entel"},
{730, 1, "Entel Telefonica Movl"},
{730, 2, "Telefnica Mvil"},
{730, 3, "Smartcom"},
{730, 4, "Centennial Cayman Corp. Chile S.A."},
{730, 5, "Multikom S.A."},
{732, 1, "Colombia Telecomunicaciones S.A. - Telecom"},
{732, 2, "Edatel S.A."},
{732, 101, "Comcel S.A. Occel S.A./Celcaribe"},
{732, 102, "Bellsouth Colombia S.A."},
{732, 103, "Colombia Mvil S.A."},
{732, 111, "Colombia Mvil S.A."},
{732, 123, "Telfnica Mviles Colombia S.A."},
{732, 130, "Avantel"},
{732, 20, "Emtelsa"},
{732, 99, "Emcali"},
{734, 1, "Infonet"},
{734, 2, "Corporacin Digitel"},
{734, 3, "Digicel"},
{734, 4, "Telcel, C.A."},
{734, 6, "Telecomunicaciones Movilnet, C.A."},
{736, 1, "Nuevatel S.A."},
{736, 2, "ENTEL S.A."},
{736, 3, "Telecel S.A."},
{738, 1, "Cel*Star (Guyana) Inc."},
{740, 0, "Otecel S.A. - Bellsouth"},
{740, 1, "Porta GSM"},
{740, 2, "Telecsa S.A."},
{744, 1, "Hola Paraguay S.A."},
{744, 2, "Hutchison Telecom S.A."},
{744, 3, "Compaia Privada de Comunicaciones S.A."},
{746, 2, "Telesur"},
{746, 3, "Digicel"},
{746, 4, "Intelsur"},
{748, 0, "Ancel - TDMA"},
{748, 10, "CTI Mvil"},
{748, 1, "Ancel - GSM"},
{748, 3, "Ancel"},
{748, 7, "Movistar"},
{901, 10, "Asia Cellular Satellite (AceS)"},
{901, 11, "Inmarsat Ltd."},
{901, 12, "Maritime Communications Partner AS (MCP network)"},
{901, 13, "Global Networks, Inc."},
{901, 14, "Telenor GSM - services in aircraft"},
{901, 15, "SITA GSM services in aircraft (On Air)"},
{901, 16, "Jasper Systems, Inc."},
{901, 17, "Jersey Telecom"},
{901, 18, "Cingular Wireless"},
{901, 19, "Vodaphone Malta"},
{901, 1, "ICO Global Communications"},
{901, 20, "Intermatica"},
{901, 21, "Seanet Maritime Communications"},
{901, 22, "Denver Consultants Ltd"},
{901, 2, "Sense Communications International AS"},
{901, 3, "Iridium Satellite, LLC (GMSS)"},
{901, 4, "Globalstar"},
{901, 5, "Thuraya RMSS Network"},
{901, 6, "Thuraya Satellite Telecommunications Company"},
{901, 7, "Ellipso"},
{901, 88, "Telecommunications for Disaster Relief (TDR) (OCHA)"},
{901, 9, "Tele1 Europe"},
{-1, -1, NULL}
};

/*
 * Return Mobile Country Code string by code.
 * Return NULL if not exists.
 */
const char *
mcc_get(int mcc)
{
	int i = 0;

	for (i = 0; i < sizeof mcc_list / sizeof *mcc_list; i++)
	{
		if (mcc_list[i].mcc == mcc)
			return mcc_list[i].data;
	}

	return NULL;
}

const char *
mnc_get(int mcc, int mnc)
{
	int i = 0;

	for (i = 0; i < sizeof mnc_list / sizeof *mnc_list; i++)
	{
		if (mnc_list[i].mcc != mcc)
			continue;
		for (; mnc_list[i].mcc == mcc; i++)
		{
			if (mnc_list[i].mnc == mnc)
				return mnc_list[i].data;
		}

		break;
	}

	return NULL;
}

